#!ruby -Ks
=begin
= config.rb
== What is this
  exerb̃ACRύX*.exe𐶐邽߂
  make.rbMakefile

== USAGE
0. config.iniҏW
   rubỹz[fBNg $ruby_home
   쐬Ώۂ̃CvO $target_main
   exerb̃RA $exerb_core

  ܂config.rbs̃IvVŎw
  (-h Ńwvo܂)

1. config.rbs
   make.rbMakefile

2. % make
    target.exerhł

== Tips
 * ACRt@Cfavicon.icoƂO
   fBNgɒuĂKv܂B

 * optparsegpĂ܂̂ŁAruby1.7ȍ~ΉłB

=end

require "optparse"

#rubỹz[fBNg
$ruby_home = "C:/cygwin/usr/local/ruby-1.8.2-i386-mswin32/"
#쐬Ώۂ̃CvO
$target_main = "target.rb"
#exerb̃RA
$exerb_core = "ruby182g.exc"

#ݒt@C()ǂݍ
if test(?r, "config.ini")
  open("config.ini") do |f|
    eval(f.read)
  end
end

#IvV
opts = OptionParser.new
opts.on_head("-h", "--help", "this help"){
  print opts.to_s
  exit
}
opts.on("-r dir", "--ruby-home dir", 
	"set ruby-directory (default #{$ruby_home})"){ |dir|
  $ruby_home = dir
}
opts.on("-t dir", "--target file", 
	"set target main code (default #{$target_main})"){ |file|
  $target_main = file
}
opts.on("-c dir", "--core file", 
	"exerb-core (default #{$exerb_core})"){ |file|
  $exerb_core = file
}
opts.parse!(ARGV)

#pXȂǂ̐ݒ -----------------------------------------
$prog_ruby = File.join($ruby_home, "bin/ruby")
if not $prog_exerb
  $prog_exerb = File.join($ruby_home, "bin/exerb")
end
if not test(?r, $exerb_core)
  $exerb_core = File.join($ruby_home, "share/exerb", $exerb_core)
end

STDERR << <<"EOS"
------------------------
build setting:
ruby:   #{$prog_ruby}
exerb:  #{$prog_exerb}
target: #{$target_main}
core:   #{$exerb_core}
------------------------
EOS

#`FbN
if not test(?r, $prog_ruby)
  STDERR << "[ERROR]program ruby not found\n" << $prog_ruby << "\n"
  exit
elsif not test(?r, $prog_exerb)
  STDERR << "[ERROR]program exerb not found\n" << $prog_exerb << "\n"
  exit
elsif not test(?r, $exerb_core)
  STDERR << "[ERROR]exerb core not found\n" << $exerb_core << "\n"
  exit
elsif not test(?r, $target_main)
  STDERR << "[ERROR]target main not found\n" << $target_main << "\n"
  exit
end

#Makefile𐶐 ---------------------------------------------
open("Makefile", "w") do |fo|
  fo << <<"EOS"
#\[X
MAIN = #{$target_main}
PROG = $(MAIN:.rb=.exe)
RECIPE = $(MAIN:.rb=.exr)
MAKFILE = $(MAIN:.rb=.mak)

#vOpX
RUBY =  #{$prog_ruby}
EXERB = #{$prog_exerb}

#------------------------------
#RpC
all: $(RECIPE) $(MAIN)
	$(RUBY) make.rb

#hLgo
doc:
	rdoc -c shift-jis

#Vst@C쐬
$(RECIPE):
	$(RUBY) -r exerb/mkexr $(MAIN)

#N[
clean:
	rm -f $(RECIPE)
	rm -f $(MAKFILE)
	rm -f $(PROG)
	rm -f -r doc

##rules
.SUFFIXES: .exe .rbc .rb .exr
EOS
end

STDERR << "\ncreate Makefile successful\n"
#create make.rb ----------------------------------------------
open("make.rb", "w") do |fo|
  fo << <<"EOS"
#!#{$prog_ruby} -Ks
=begin
=make.rb
== What is this
  exet@CACRύX쐬rhpXNvg
  config.rb玩

== Author
  ghiaccio@plala.to
=end

require "exerb/executable"
require "exerb/resource"
require "exerb/recipe"

TARGET = "#{$target_main.gsub(".rb", "")}"
ICON = "favicon.ico"

RECIPE = TARGET + ".exr"
OUTPUT = TARGET + ".exe"
CORE = "#{$exerb_core}"

#ACR̎w
icon16 = Exerb::Resource::Icon.new_from_file(ICON, 16, 16, 8)
icon32 = Exerb::Resource::Icon.new_from_file(ICON, 32, 32, 8)
group_icon = Exerb::Resource::GroupIcon.new
group_icon.add(1, icon16)
group_icon.add(2, icon32)
 
recipe = Exerb::Recipe.new_from_file(RECIPE)
executable = Exerb::Executable.new_from_file(CORE)
executable.rsrc.add_icon(1, icon16)
executable.rsrc.add_icon(2, icon32)
executable.rsrc.add_group_icon(100, group_icon)
executable.rsrc.add_archive(recipe.archive)
executable.write_to_file(OUTPUT)

EOS
end

STDERR << "create make.rb successful\n\n"
