#!ruby -Ks
=begin rdoc
= rdstyle.rb
̃t@CŒ`NX

* RDtitle
  ^Cg擾ƕύXȂǂ̑A^Cgf[^ǗNX

* RDtitle::RDchapterform

  `v^[̃tH[ێNX
  (RDtitleŎgA[U[͐GȂ)

* RDmember

  X̃^CgێNX
  (RDtitlegp)

* RDhttp

  RDƂhttpʐMǗNX
  (RDtitlegp)

Developers:: ghiaccio@plala.to

:title:RDstyle RDoc
=end
$KCODE = 's'

require "net/http"
require "kconv"
require "net/ftp"
require "CGI"
require "digest/md5"
require "base64"

#܂Ȃ
Net::HTTP.version_1_2

#== RDtitle
#^Cg擾ƑSǗNX
#
#RD-X3/RD-X5/RD-X6p
#
#̃NXN鎖őS^Cg擾B
#
#all \bhŃ^Cg(XRDmemberNX)̓z𑀍oB
#=== USAGE
#1. N(ɑS^Cg擾/Ԃ܂)
#    rdstyle = RDtitle.new(host, user, password)
#2. Ⴆ΁Acsv`őSf[^o
#    print rdstyle.to_csv

class RDtitle

  # RD̃lbgdeirɃOCAf[^擾B
  #
  # host zXg
  # user [U[
  # password pX[h
  def initialize(host, user, password)

    # RDhttpNX
    @rdhttp = RDhttp.new(host, user, password)
    @db = Array.new
    @dbf = Array.new
    @db_n2m = Hash.new

    # get_rootɂS^Cg擾
    get_root()
    set_no2member()
  end

  #S^f[^Ԃ
  #(RDmember̓z)
  def all
    return @db
  end

  #StH_f[^Ԃ
  #(tH_[RDmember̓z)
  def all_folder
    return @dbf
  end

  #ԍ͂烁o[Ԃ
  def no2member(no)
    return @db_n2m[no.to_i]
  end
  
  #[g^Cgꗗ̎擾ƃtH_̃t@C擾
  #f[^@dbɊi[
  def get_root
    src = @rdhttp.getcontents("/title/b_title.htm")
    #G[,G[𔭐ďI
    if src =~ /^ERROR/
      raise src
    end
    
    case @rdhttp.rdtype 
    when "x5"
      get_root_rdx5(src)
    when "x3"
      get_root_rdx3(src)
    end

  end

  
  #tH_^Cg̎擾
  #folder̓tH_\RDmemberNX
  def get_folder(folder)
    #STDERR << folder.uri << "\n"
    src = @rdhttp.getcontents(folder.uri)

    src.scan(/^c1[\S\s]+?$/) do |scan| #/
      member = java2member(scan)
      member.set_folder(folder)
      @db << member
    end
  end

  #`v^[擾
  def get_chapter(no)
    #STDERR << @db[1].uri << "\n"
    src = @rdhttp.getcontents(@db[1].uri)
    parse_chapter(src)
  end

  #^Cg̕ύX
  #memberRDmemberIuWFNg
  #newtitle͐VK^Cg
  def change_title(member, newtitle)
    src = @rdhttp.getcontents(member.uri)
    if src =~ /^ERROR/
      raise src
    end

    cform = parse_chapter(src)
    cform.change_title(newtitle)
    response = @rdhttp.post_cform(cform)
    response = Kconv.tosjis(response.gsub(/\\r|\\n/, ""))
    if response =~ /ɓo^/ or response =~ /actfnc\(\)/
      member.title = newtitle
    end
    return response

    #	STDERR << "[RDtitle] ERROR on change_title\n"
    #	exit
    #end

  end

  #Sf[^csv
  def to_csv
    buf = ""
    @db.each do |item|
      buf << item.to_csv
    end
    return buf
  end

  #private method----------------------------------------------

  #rd-x3^Cv̉
  def get_root_rdx3(src)
    #html
    src.scan(/<tr[^>]*?>([\S\s]+?)<\/tr>/) do |scan_tr| #/
      scan_td = scan_tr[0].scan(/<td[^>]*?>([\S\s]*?)<\/td>/) #/
      newmember = RDmember.new
      newmember.src = deletetag(scan_td[0][0])
      newmember.no = (deletetag(scan_td[1][0]).to_i)
      newmember.uri = tagscan(scan_td[2][0], "a")[0][0]["href"]
      newmember.title = deletetag(scan_td[2][0])
      newmember.zokusei = (scan_td[3][0] =~ /origin/ ? "original" : "playlist")
      newmember.ch = deletetag(scan_td[4][0])
      newmember.date = deletetag(scan_td[5][0])
      newmember.genre = deletetag(scan_td[8][0])
      newmember.protect = deletetag(scan_td[9][0])
      @db << newmember
    end
  end
  private :get_root_rdx3

  #rd-x5^Cv̉
  def get_root_rdx5(src)
    #html
    src.scan(/^c1[\S\s]+?$/) do |scan| #/
      member = java2member(scan)
      if member.is_folder?
	@dbf << member
      else
	@db << member
      end
    end
    
    #StH_擾
    @dbf.each do |folder|
      get_folder(folder)
    end
  end
  private :get_root_rdx5

  #ԍƃo[̑Ή\쐬
  def set_no2member
    @db.each do |member|
      @db_n2m[member.no] = member
    end
  end
  private :set_no2member

  #^O
  def deletetag(string)
    string.gsub(/<[^>]*>/, "")
  end
  private :deletetag
  
  #`v^[y[W
  def parse_chapter(buf)

    formatr = tagscan(buf, "form")
    targeturl = formatr[0][0]["action"]

    cform = RDchapterform.new(targeturl)

    #tH[̉
    inputs = tagscan(buf, "input")
    inputs.each do |hash, pos|
      if hash["name"]
	cform.set(hash["name"], hash["value"], pos)
      end
    end
    #ZNg^Ỏ
    selects = tagscan_select(buf)
    selects.each do |hash, pos|
      if hash["name"]
	cform.set(hash["name"], hash["value"], pos)
      end
    end
    
    #eLXgGA
    textareas = tagscan_textarea(buf)
    textareas.each do |hash, pos|
      if hash["name"]
	cform.set(hash["name"], hash["value"], pos)
      end
    end

    return cform

  end
  private :parse_chapter
  #javascriptRDmemberIuWFNg
  def java2member(data)
    scan = data.scan(/c(\d+)\[\d+\]\=([\S\s]+?)\;/)
    newmember = RDmember.new
    newmember.setdata(scan)
    return newmember
  end
  private :java2member

  #html^OT
  def tagscan(data, tag)
    out = Array.new
    data.scan(/\<#{tag}([^\>]*)\>/i) do |attribute|
      #}b`ʒu̕ێ
      pos = data.index($&)

      if attribute[0] !~ /disabled/
	#
	atr = Hash.new
	attribute[0].scan(/(\w+)=(\S+)/) do |pt| 
	  atr[ pt[0] ] = pt[1]
	end
	attribute[0].scan(/(\w+)="([^"]*)"/) do |pt| 
	  atr[ pt[0] ] = pt[1]
	end
	out << [atr, pos]
      end
      
    end
    return out
  end
  private :tagscan

  #html^OT selectp
  def tagscan_select(data)
    out = Array.new
    data.scan(/\<select([^\>]*)\>([\S\s]*?)<\/select\>/i) do |attribute, options| #/

      #}b`ʒu̕ێ
      pos = data.index($&)

      atr = Hash.new
      attribute.scan(/(\w+)\s*=\s*(\S+)/) do |pt| 
	atr[pt[0]] = pt[1] 
      end
      attribute.scan(/(\w+)\s*=\s*"([^"]*)"/) do |pt| 
	atr[pt[0]] = pt[1]
      end
      option_value = options.scan(/\<option value\=\"(\S+?)\" selected\>/)

      #for rd-x6 patch
      #set_pagewb|RȏɂȂĂ..
      if not option_value or not option_value[0]
	option_value = options.scan(/\<option selected\>([^\<]+)</i)
      end
      
      if option_value and option_value[0]
	atr["value"] = option_value[0][0]
      end
      out << [atr, pos]

    end
    return out
  end
  private :tagscan_select

  #html^OT textareap
  def tagscan_textarea(data)
    out = Array.new
    data.scan(/\<textarea([^\>]*)\>([\S\s]*?)\<\//i) do |attribute, value| #/
      #}b`ʒu̕ێ
      pos = data.index($&)

      atr = Hash.new
      attribute.scan(/(\w+)=(\S+)/) do |pt| 
	atr[pt[0]] = pt[1] 
      end
      attribute.scan(/(\w+)="([^"]*)"/) do |pt| 
	atr[pt[0]] = pt[1]
      end
      atr["value"] = value
      out << [atr, pos]
    end
    return out
  end
  private :tagscan_textarea

  #== RDchapterform
  #`v^[̃tH[NX 
  #RDtitlepNXŃ[U[G鎖͖
  class RDchapterform
    #
    def initialize(target)
      @target = target
      @value = Hash.new
      @sort = Hash.new
    end

    #f[^Zbg
    def set(name, value, pos)
      @value[name] = value
      @sort[name] = pos
    end

    #\[gɕ
    def postdata
      buf = ""
      @sort.to_a.sort{|a, b| a[1] <=> b[1]}.each do |name, pos|
	buf << format("%s=%s&", name, CGI.escape(@value[name]))
      end
      return buf.chop
    end

    #^CgύX
    def change_title(newtitle)
      @value["titlename"] = newtitle
    end

    attr_reader(:target)
  end
end

#== RDmember
#^Cgꗗ̌X̃^CgێNX
class RDmember

  #ŏ
  def initialize()
    @src = nil      #dvd/hdd    c0
    @no = nil       #ԍ       c1
    @title = nil    #^Cg   c2
    @ch = nil       #`l c3
    @date = nil     #t       c4
    @genre = nil    #W   c5
    @protect = nil  #ی       c6
    @zokusei = nil  #       c13
    @uri = nil
    @folder = nil
  end

  #f[^Zbg
  #datajavascripẗ
  def setdata(data)
    @data = data
    @src   = c(1)
    @no    = c(2).to_i
    @title = c(3).gsub(/<[^>]*>/, "")
    @ch    = c(4)
    @date  = c(5)
    @genre = c(6)
    @protect = c(7)
    #uri tH_ƂȊOňႤ
    iconfile = c(13)

    if iconfile =~ /^S_|folder|trash/i 
      @uri = "b_title.htm?disc=" + c(10) + "&folder=" + c(8)
      @zokusei = (iconfile =~ /trash/i ? "folder_trash" : "folder")
    else
      @uri = "b_chpt.htm?Title_No=" + c(8) + "&Title_type=" + c(9) + 
        "&Target_drive=" + c(10) + "&Disp_No=" + c(11)
      @zokusei = (iconfile =~ /original/i ? "original" : "playlist")
    end

  end

  #etH_Zbg
  def set_folder(input_folder)
    @folder = input_folder
  end

  #tH_̏ꍇtrueԂ
  def is_folder?
    return (@zokusei =~ /folder/)
  end

  #tH_[Ԃ
  def folder_name
    return (@folder ? @folder.title : "root")
  end

  #Time.strftime (N//̂ 0)Ԃ
  def time
    return Time.local(@date[0, 4].to_i, @date[5, 2].to_i, @date[8, 2].to_i)
  end
  
  #csv`̃eLXgԂ
  def to_csv
    [@src, @zokusei, @no.to_s, @title, @ch, @date, @genre, @protect, 
      folder_name].join(",") + "\n"
  end

  #javascript̔z`
  def c(no)
    return cleandata(no - 1)
  end
  private :c

  #NIe[VOԂ
  def cleandata(no)
    return @data[no][1].gsub(/\"/, "")
  end
  private :cleandata

  #ԍ
  attr_accessor(:no)
  #^Cg
  attr_accessor(:title)
  #`l
  attr_accessor(:ch)
  #t
  attr_accessor(:date)
  #`v^[y[Wuri
  attr_accessor(:uri)
  #یی
  attr_accessor(:protect)
  #W
  attr_accessor(:genre)
  #
  attr_accessor(:zokusei)
  #\[X
  attr_accessor(:src)

end

#== RDhttp
#httpoRŏ擾NX
#RDtitle瑀삳A[U[͐GȂ
class RDhttp

  #http
  def initialize(host, user, password)
    #zXg/|[gԍ
    if host =~ /^([\S\s]+?)\:(\d+?)$/
      @host = $1
      @port = $2.to_i
    else
      @host = host
      @port = 80
    end
    
    @rdtype = nil
    @session = nil
    @header = Hash.new
    @user = user
    @password = password
    @nc = "00000001"
    @auth_type = "" #F؂̃^Cv
  end
  
  #rd̃^Cv(x3/x5)
  attr_reader(:rdtype)

  #t[擾
  def getframe(url)
    out = Hash.new
    main_txt = get(url)
    main_txt.each_line do |line|
      if line =~ /\<frame\ssrc\=\"(.+?)\"\s+name\=\"(.+?)\"/
	frame_file = $1
	frame_name = $2
	# STDERR << $1 << "\n"
	#΃pX̏ꍇA΃pXɕϊ
	if frame_file !~ /^\// #/
	  # frame_file =  "/" + frame_file
	  frame_file = "/title" + frame_file.gsub(/\.\./, "") #/
	end

	#p frame_file
	frame_txt = get(frame_file)
	out[frame_name] = frame_txt
      end
    end
    return out
  end

  #t[[contents]ƂÕy[WeԂ
  def getcontents(uri)
    main_txt = get(correct_uri(uri))
    main_txt.each_line do |line|
      if line =~ /\<frame\ssrc\=\"(.+?)\"\s+name\=\"(.+?)\"/
	frame_file = $1
	frame_name = $2

	if frame_name =~ /(main|contents)/
	  #rd̋@^Cv킩H
	  if not @rdtype
	    @rdtype = (frame_name == "main" ? "x3" : "x5")
	  end

	  #΃pX̏ꍇA΃pXɕϊ
	  if frame_file !~ /^\// #/
	    frame_file = "/title" + frame_file.gsub(/\.\./, "") #/
	  end
	  #ZbVԍύX
	  set_session(frame_file)
	  buf = get(frame_file)

	  #G[`FbN
	  error_msg = parse_error(buf)
	  if error_msg
	    return "ERROR " + error_msg
	  end

	  #I
	  return buf
	end
      end
    end
    #ȂƂG[𔭐
    error_msg = parse_error(main_txt)
    if error_msg 
      raise "ERROR " + error_msg
    else
      raise "ERROR " + main_txt
    end
  end

  #`v^[̃tH[𑗐M
  def post_cform(rdcform)
    return post(correct_uri(rdcform.target), rdcform.postdata)
  end

  #uriC
  def correct_uri(uri)
    if uri !~ /^\// #/
      return format("/title/%s/%s", @session, uri)
    else
      return uri
    end
  end

  #lbgR̃R[hM
  def get_netremocon(code)
    url = format("/remote/remote.htm?key=%s", code.upcase)
    return get(url)
  end
  
  #lbgL[{[h̕񑗐M
  def get_netkeyboard(new_str)
    #GET /remote/netkeyboard.htm?str=xxxxx
    url = format("/remote/netkeyboard.htm?str=%s", CGI.escape(new_str))
    return get(url)
  end

  #^Co[̎M
  def get_timebar(new_time)
    url = format("/remote/ts.htm?%d", new_time.to_i)
    return get(url)
  end

  private 
  #G[bZ[W
  def parse_error(buf)
    if buf =~ /actfnc\(\)/
      if @rdtype == "x5" and buf =~ /msg=\"([^\"]*)\"/
	return $1.gsub(/\\r|\\n/, "")
      elsif @rdtype == "x3" and buf =~ /alert\(\"([^\"]*)\"/
	return $1.gsub(/\\r|\\n/, "")
      end
    end
    return nil
  end
  
  #ZbVԍ̕ێ
  def set_session(uri)
    if uri =~ /\/title\/(\d+)\// #/
      @session = $1
    else
      raise "ERROR on RDhttp::set_session"
    end
  end

  #httpoRŎ擾郍[x\bh
  def get(uri)
    buf = ""
    STDERR << "GET " << uri << "\n" if $DEBUG
    Net::HTTP.start(@host, @port) do |http|
      #^CAEg
      http.open_timeout = 5

      #̏ꍇxŎɂAFؕm
      if @auth_type == ""
	response_pre = http.get(uri)
	#p response_pre.code
	case response_pre.code
	when "401"
	  #F؂Kvȏꍇ
	  if response_pre["www-authenticate"]
	    #F؂̃^Cv𓾂
	    case response_pre["www-authenticate"]
	    when /Basic/i
	      #basicF
	      @auth_type = "basic"
	      @header["Authorization"] = 'Basic ' + 
		["#{@user}:#{@password}"].pack('m').strip
	    when /Digest/i
	      #DigestF
	      @auth_type = "digest"
	      set_authinfo(response_pre["www-authenticate"])
	    end
	  end
	  
	else
	  #pX[hȂ̏ꍇ
	  @auth_type = "raw"
	end
      end

      #digestF؂̏ꍇ̃wb_C
      if @auth_type == "digest"
	@header["Authorization"] = make_digest("GET", uri)
      end
      #p @header
      response = http.get(uri, @header)
      buf << response.body
    end
    return buf
  end


  #httpoRPOST郍[x\bh
  def post(uri, postdata)
    buf = ""
    STDERR << "POST " << uri << "\n" if $DEBUG
    
    Net::HTTP.start(@host, @port) do |http|

      #digestF؂̏ꍇ̃wb_C
      if @auth_type == "digest"
	@header["Authorization"] = make_digest("POST", uri)
      end

      http.open_timeout = 5
      response = http.post(uri, postdata, @header)
      buf << response.body
    end
    
    #bZ[W͂āÂ̕ݕԂ
    if buf =~ /msg=\"([^\"]*)\"/
      return $1
    elsif buf =~ /alert\(\"([^\"]*)\"/
      return $1
    end
    return buf
  end
  
  #X|X̃fobO\p
  def debug_response(response)
    response.each do |key, value|
      printf("%s: %s\n", key, value)
    end
  end

  #digestFؗp
  def set_authinfo(auth)
    @auth_info = Hash.new
    auth.scan(/(\S+)\=\"([^\"]+)\"/) do |ary|
      @auth_info[ary[0]] = ary[1]
    end
  end

  #digestF؂̃X|Xwb_
  def make_digest(method, uri)
    @nc.succ!
    cnonce = '0123456789' #{͗
    a1 = "#{@user}:#{@auth_info['realm']}:#{@password}"
    h_a1 = Digest::MD5.hexdigest(a1)
    a2 = "#{method}:#{uri}"
    h_a2 = Digest::MD5.hexdigest(a2)
    response = "#{h_a1}:#{@auth_info['nonce']}:#{@nc}:#{cnonce}:auth:#{h_a2}"
    h_response = Digest::MD5.hexdigest(response)
    
    return format(%Q!Digest username="%s", realm="%s", nonce="%s", uri="%s", algorithm=MD5, qop=auth, nc=%s, cnonce="%s", response="%s"!, 
		  @user, @auth_info["realm"], @auth_info["nonce"], 
		  uri, @nc, cnonce, h_response)
  end

end

#test main ------------------------

if __FILE__ == $0
  require "optparse"

  #R}hC
  def commandline(prompt)
    STDERR << prompt
    return STDIN.gets.chomp
  end
  
  host, user, pass = "", "", ""
  #IvV
  opts = OptionParser.new
  opts.on("-r RD_HOSTNAME", "set rdhost(rd-x6/rd-x5/rd-x3)"){|val| host = val}
  opts.on("-u USER_NAME", "set username (default input)"){|val| user = val}
  opts.on("-p PASSWORD", "set password (default input)"){|val| pass = val}
  opts.on_head("-h", "--help", "Show this message") do
    STDERR << opts
    exit
  end

  begin
    opts.parse!(ARGV)
  rescue
    STDERR << opts.to_s
    exit
  end

  #͂ȂꍇAR}hCŎ擾
  host = commandline("rd-hostname: ") if host == ""
  user = commandline("username: ") if user == ""
  pass = commandline("password: ") if pass == ""

  #rdstyleNXN
  STDERR << "now connecting ..."
  rdstyle = RDtitle.new(host, user, pass)
  STDERR << "done\n"
  #csvo̓eXg
  print rdstyle.to_csv
  
end
#end of this program
